<html>
<head>
<title>OGRE: OgreRenderQueueSortingGrouping.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreRenderQueueSortingGrouping.h</h1><a href="OgreRenderQueueSortingGrouping_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __RenderQueueSortingGrouping_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __RenderQueueSortingGrouping_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="comment">// Precompiler options</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreMaterial_8h.html">OgreMaterial.h</a>"</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include "<a class="code" href="OgreTechnique_8h.html">OgreTechnique.h</a>"</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include "<a class="code" href="OgrePass_8h.html">OgrePass.h</a>"</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include "<a class="code" href="OgreRadixSort_8h.html">OgreRadixSort.h</a>"</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">namespace </span>Ogre {
<a name="l00041"></a>00041 
<a name="l00046"></a><a class="code" href="structOgre_1_1RenderablePass.html">00046</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1RenderablePass.html" title="Struct associating a single Pass with a single Renderable.">RenderablePass</a>
<a name="l00047"></a>00047     {
<a name="l00049"></a><a class="code" href="structOgre_1_1RenderablePass.html#88788b24efb00ee4d9cf8c4b75cf06ee">00049</a>         <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* <a class="code" href="structOgre_1_1RenderablePass.html#88788b24efb00ee4d9cf8c4b75cf06ee" title="Pointer to the Renderable details.">renderable</a>;
<a name="l00051"></a><a class="code" href="structOgre_1_1RenderablePass.html#ec7289b1a870e7c39d83b5d422792990">00051</a>         <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>* <a class="code" href="structOgre_1_1RenderablePass.html#ec7289b1a870e7c39d83b5d422792990" title="Pointer to the Pass.">pass</a>;
<a name="l00052"></a>00052 
<a name="l00053"></a><a class="code" href="structOgre_1_1RenderablePass.html#ced02c6752335dbd5bd4ff1681c35882">00053</a>         <a class="code" href="structOgre_1_1RenderablePass.html#ced02c6752335dbd5bd4ff1681c35882">RenderablePass</a>(<a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* rend, <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>* p) :<a class="code" href="structOgre_1_1RenderablePass.html#88788b24efb00ee4d9cf8c4b75cf06ee" title="Pointer to the Renderable details.">renderable</a>(rend), <a class="code" href="structOgre_1_1RenderablePass.html#ec7289b1a870e7c39d83b5d422792990" title="Pointer to the Pass.">pass</a>(p) {}
<a name="l00054"></a>00054     };
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00064"></a><a class="code" href="classOgre_1_1QueuedRenderableVisitor.html">00064</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1QueuedRenderableVisitor.html" title="Visitor interface for items in a QueuedRenderableCollection.">QueuedRenderableVisitor</a>
<a name="l00065"></a>00065     {
<a name="l00066"></a>00066     <span class="keyword">public</span>:
<a name="l00067"></a><a class="code" href="classOgre_1_1QueuedRenderableVisitor.html#a639df153b7748f890d3d11d64e6a0e8">00067</a>         <a class="code" href="classOgre_1_1QueuedRenderableVisitor.html" title="Visitor interface for items in a QueuedRenderableCollection.">QueuedRenderableVisitor</a>() {}
<a name="l00068"></a><a class="code" href="classOgre_1_1QueuedRenderableVisitor.html#9e9fca8d2b7fd4c75a24b6c7f8b1b234">00068</a>         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1QueuedRenderableVisitor.html" title="Visitor interface for items in a QueuedRenderableCollection.">QueuedRenderableVisitor</a>() {}
<a name="l00069"></a>00069         
<a name="l00076"></a>00076         <span class="keyword">virtual</span> <span class="keywordtype">void</span> visit(<span class="keyword">const</span> <a class="code" href="structOgre_1_1RenderablePass.html" title="Struct associating a single Pass with a single Renderable.">RenderablePass</a>* rp) = 0;
<a name="l00077"></a>00077 
<a name="l00078"></a>00078         <span class="comment">/* When visiting a collection grouped by pass, this is</span>
<a name="l00079"></a>00079 <span class="comment">            called when the grouping pass changes.</span>
<a name="l00080"></a>00080 <span class="comment">        @remarks</span>
<a name="l00081"></a>00081 <span class="comment">            If this method is called, the RenderablePass visit </span>
<a name="l00082"></a>00082 <span class="comment">            method will not be called for this collection. The </span>
<a name="l00083"></a>00083 <span class="comment">            Renderable visit method will be called for each item</span>
<a name="l00084"></a>00084 <span class="comment">            underneath the pass grouping level.</span>
<a name="l00085"></a>00085 <span class="comment">        @returns True to continue, false to skip the Renderables underneath</span>
<a name="l00086"></a>00086 <span class="comment">        */</span>
<a name="l00087"></a>00087         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> visit(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>* p) = 0;
<a name="l00094"></a>00094         <span class="keyword">virtual</span> <span class="keywordtype">void</span> visit(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* r) = 0;
<a name="l00095"></a>00095         
<a name="l00096"></a>00096         
<a name="l00097"></a>00097     };
<a name="l00098"></a>00098 
<a name="l00108"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html">00108</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a>
<a name="l00109"></a>00109     {
<a name="l00110"></a>00110     <span class="keyword">public</span>:
<a name="l00119"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#b44ba16fe8e8c0247234d4e6edfae844">00119</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html#b44ba16fe8e8c0247234d4e6edfae844" title="Organisation modes required for this collection.">OrganisationMode</a>
<a name="l00120"></a>00120         {
<a name="l00122"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#b44ba16fe8e8c0247234d4e6edfae8445cb7861265877a6f1f0a4b3508df7014">00122</a>             OM_PASS_GROUP = 1,
<a name="l00124"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#b44ba16fe8e8c0247234d4e6edfae844aec5c102c9894feda331832a82738d72">00124</a>             OM_SORT_DESCENDING = 2,
<a name="l00128"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#b44ba16fe8e8c0247234d4e6edfae8442cb722796eba6d25f8f7e8d7a4738241">00128</a>             OM_SORT_ASCENDING = 6
<a name="l00129"></a>00129         };
<a name="l00130"></a>00130 
<a name="l00131"></a>00131     <span class="keyword">protected</span>:
<a name="l00133"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1PassGroupLess.html">00133</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1PassGroupLess.html" title="Comparator to order pass groups.">PassGroupLess</a>
<a name="l00134"></a>00134         {
<a name="l00135"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1PassGroupLess.html#9600b8c32a4c168e3f7f58f8eeeaccd2">00135</a>             <span class="keywordtype">bool</span> <a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> operator()(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>* a, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>* b)<span class="keyword"> const</span>
<a name="l00136"></a>00136 <span class="keyword">            </span>{
<a name="l00137"></a>00137                 <span class="comment">// Sort by passHash, which is pass, then texture unit changes</span>
<a name="l00138"></a>00138                 <a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> hasha = a-&gt;<a class="code" href="classOgre_1_1Pass.html#c653a9c44ddaef38b8d3bc02d9edc30b" title="Gets the &amp;#39;hash&amp;#39; of this pass, ie a precomputed number to use for sorting...">getHash</a>();
<a name="l00139"></a>00139                 <a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> hashb = b-&gt;<a class="code" href="classOgre_1_1Pass.html#c653a9c44ddaef38b8d3bc02d9edc30b" title="Gets the &amp;#39;hash&amp;#39; of this pass, ie a precomputed number to use for sorting...">getHash</a>();
<a name="l00140"></a>00140                 <span class="keywordflow">if</span> (hasha == hashb)
<a name="l00141"></a>00141                 {
<a name="l00142"></a>00142                     <span class="comment">// Must differentTransparentQueueItemLessiate by pointer incase 2 passes end up with the same hash</span>
<a name="l00143"></a>00143                     <span class="keywordflow">return</span> a &lt; b;
<a name="l00144"></a>00144                 }
<a name="l00145"></a>00145                 <span class="keywordflow">else</span>
<a name="l00146"></a>00146                 {
<a name="l00147"></a>00147                     <span class="keywordflow">return</span> hasha &lt; hashb;
<a name="l00148"></a>00148                 }
<a name="l00149"></a>00149             }
<a name="l00150"></a>00150         };
<a name="l00152"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1DepthSortDescendingLess.html">00152</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1DepthSortDescendingLess.html" title="Comparator to order objects by descending camera distance.">DepthSortDescendingLess</a>
<a name="l00153"></a>00153         {
<a name="l00154"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1DepthSortDescendingLess.html#59ff46e2fa195e05f28518e32c07c7db">00154</a>             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* camera;
<a name="l00155"></a>00155 
<a name="l00156"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1DepthSortDescendingLess.html#d7c5f19a708502c538b73c7ee8e3ca1f">00156</a>             <a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1DepthSortDescendingLess.html" title="Comparator to order objects by descending camera distance.">DepthSortDescendingLess</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam)
<a name="l00157"></a>00157                 : camera(cam)
<a name="l00158"></a>00158             {
<a name="l00159"></a>00159             }
<a name="l00160"></a>00160 
<a name="l00161"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1DepthSortDescendingLess.html#e7f6866b54ba54e39ad26d5b706771aa">00161</a>             <span class="keywordtype">bool</span> <a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> operator()(<span class="keyword">const</span> <a class="code" href="structOgre_1_1RenderablePass.html" title="Struct associating a single Pass with a single Renderable.">RenderablePass</a>&amp; a, <span class="keyword">const</span> <a class="code" href="structOgre_1_1RenderablePass.html" title="Struct associating a single Pass with a single Renderable.">RenderablePass</a>&amp; b)<span class="keyword"> const</span>
<a name="l00162"></a>00162 <span class="keyword">            </span>{
<a name="l00163"></a>00163                 <span class="keywordflow">if</span> (a.<a class="code" href="structOgre_1_1RenderablePass.html#88788b24efb00ee4d9cf8c4b75cf06ee" title="Pointer to the Renderable details.">renderable</a> == b.<a class="code" href="structOgre_1_1RenderablePass.html#88788b24efb00ee4d9cf8c4b75cf06ee" title="Pointer to the Renderable details.">renderable</a>)
<a name="l00164"></a>00164                 {
<a name="l00165"></a>00165                     <span class="comment">// Same renderable, sort by pass hash</span>
<a name="l00166"></a>00166                     <span class="keywordflow">return</span> a.<a class="code" href="structOgre_1_1RenderablePass.html#ec7289b1a870e7c39d83b5d422792990" title="Pointer to the Pass.">pass</a>-&gt;<a class="code" href="classOgre_1_1Pass.html#c653a9c44ddaef38b8d3bc02d9edc30b" title="Gets the &amp;#39;hash&amp;#39; of this pass, ie a precomputed number to use for sorting...">getHash</a>() &lt; b.<a class="code" href="structOgre_1_1RenderablePass.html#ec7289b1a870e7c39d83b5d422792990" title="Pointer to the Pass.">pass</a>-&gt;<a class="code" href="classOgre_1_1Pass.html#c653a9c44ddaef38b8d3bc02d9edc30b" title="Gets the &amp;#39;hash&amp;#39; of this pass, ie a precomputed number to use for sorting...">getHash</a>();
<a name="l00167"></a>00167                 }
<a name="l00168"></a>00168                 <span class="keywordflow">else</span>
<a name="l00169"></a>00169                 {
<a name="l00170"></a>00170                     <span class="comment">// Different renderables, sort by depth</span>
<a name="l00171"></a>00171                     <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> adepth = a.<a class="code" href="structOgre_1_1RenderablePass.html#88788b24efb00ee4d9cf8c4b75cf06ee" title="Pointer to the Renderable details.">renderable</a>-&gt;<a class="code" href="classOgre_1_1Renderable.html#32353addc2f1d02512314b5d1a53c5c1" title="Returns the camera-relative squared depth of this renderable.">getSquaredViewDepth</a>(camera);
<a name="l00172"></a>00172                     <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> bdepth = b.<a class="code" href="structOgre_1_1RenderablePass.html#88788b24efb00ee4d9cf8c4b75cf06ee" title="Pointer to the Renderable details.">renderable</a>-&gt;<a class="code" href="classOgre_1_1Renderable.html#32353addc2f1d02512314b5d1a53c5c1" title="Returns the camera-relative squared depth of this renderable.">getSquaredViewDepth</a>(camera);
<a name="l00173"></a>00173                     <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1Math.html#890336e0e4b6914024bfefd79c08f432" title="Compare 2 reals, using tolerance for inaccuracies.">Math::RealEqual</a>(adepth, bdepth))
<a name="l00174"></a>00174                     {
<a name="l00175"></a>00175                         <span class="comment">// Must return deterministic result, doesn't matter what</span>
<a name="l00176"></a>00176                         <span class="keywordflow">return</span> a.<a class="code" href="structOgre_1_1RenderablePass.html#ec7289b1a870e7c39d83b5d422792990" title="Pointer to the Pass.">pass</a> &lt; b.<a class="code" href="structOgre_1_1RenderablePass.html#ec7289b1a870e7c39d83b5d422792990" title="Pointer to the Pass.">pass</a>;
<a name="l00177"></a>00177                     }
<a name="l00178"></a>00178                     <span class="keywordflow">else</span>
<a name="l00179"></a>00179                     {
<a name="l00180"></a>00180                         <span class="comment">// Sort DESCENDING by depth (ie far objects first)</span>
<a name="l00181"></a>00181                         <span class="keywordflow">return</span> (adepth &gt; bdepth);
<a name="l00182"></a>00182                     }
<a name="l00183"></a>00183                 }
<a name="l00184"></a>00184 
<a name="l00185"></a>00185             }
<a name="l00186"></a>00186         };
<a name="l00187"></a>00187 
<a name="l00191"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#d820db5042693a75be0267bbe018869e">00191</a>         <span class="keyword">typedef</span> std::vector&lt;RenderablePass&gt; RenderablePassList;
<a name="l00192"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#8d0649f312e57548ccd021337e3c56bd">00192</a>         <span class="keyword">typedef</span> std::vector&lt;Renderable*&gt; RenderableList;
<a name="l00194"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#7860489c24be0b6e45308b5e6dda8b64">00194</a>         <span class="keyword">typedef</span> std::map&lt;Pass*, RenderableList*, PassGroupLess&gt; PassGroupRenderableMap;
<a name="l00195"></a>00195 
<a name="l00197"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1RadixSortFunctorPass.html">00197</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1RadixSortFunctorPass.html" title="Functor for accessing sort value 1 for radix sort (Pass).">RadixSortFunctorPass</a>
<a name="l00198"></a>00198         {
<a name="l00199"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1RadixSortFunctorPass.html#b22672c70231fc47358363b432009b12">00199</a>             <a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> operator()(<span class="keyword">const</span> <a class="code" href="structOgre_1_1RenderablePass.html" title="Struct associating a single Pass with a single Renderable.">RenderablePass</a>&amp; p)<span class="keyword"> const</span>
<a name="l00200"></a>00200 <span class="keyword">            </span>{
<a name="l00201"></a>00201                 <span class="keywordflow">return</span> p.<a class="code" href="structOgre_1_1RenderablePass.html#ec7289b1a870e7c39d83b5d422792990" title="Pointer to the Pass.">pass</a>-&gt;<a class="code" href="classOgre_1_1Pass.html#c653a9c44ddaef38b8d3bc02d9edc30b" title="Gets the &amp;#39;hash&amp;#39; of this pass, ie a precomputed number to use for sorting...">getHash</a>();
<a name="l00202"></a>00202             }
<a name="l00203"></a>00203         };
<a name="l00204"></a>00204 
<a name="l00206"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#760cf336631fb24e6f6cc2fb45c850a1">00206</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1RadixSort.html" title="Class for performing a radix sort (fast comparison-less sort based on byte value)...">RadixSort&lt;RenderablePassList, RenderablePass, uint32&gt;</a> msRadixSorter1;
<a name="l00207"></a>00207 
<a name="l00209"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1RadixSortFunctorDistance.html">00209</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1RadixSortFunctorDistance.html" title="Functor for descending sort value 2 for radix sort (distance).">RadixSortFunctorDistance</a>
<a name="l00210"></a>00210         {
<a name="l00211"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1RadixSortFunctorDistance.html#ebb10cc09cd68a0150517507e71a2b66">00211</a>             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* camera;
<a name="l00212"></a>00212 
<a name="l00213"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1RadixSortFunctorDistance.html#3127f7533114a2b5887532f4c207afec">00213</a>             <a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1RadixSortFunctorDistance.html" title="Functor for descending sort value 2 for radix sort (distance).">RadixSortFunctorDistance</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam)
<a name="l00214"></a>00214                 : camera(cam)
<a name="l00215"></a>00215             {
<a name="l00216"></a>00216             }
<a name="l00217"></a>00217 
<a name="l00218"></a><a class="code" href="structOgre_1_1QueuedRenderableCollection_1_1RadixSortFunctorDistance.html#dc57cb46c570fb3e0dd3d1b6089dd6cf">00218</a>             <span class="keywordtype">float</span> operator()(<span class="keyword">const</span> <a class="code" href="structOgre_1_1RenderablePass.html" title="Struct associating a single Pass with a single Renderable.">RenderablePass</a>&amp; p)<span class="keyword"> const</span>
<a name="l00219"></a>00219 <span class="keyword">            </span>{
<a name="l00220"></a>00220                 <span class="comment">// Sort DESCENDING by depth (ie far objects first), use negative distance</span>
<a name="l00221"></a>00221                 <span class="comment">// here because radix sorter always dealing with accessing sort</span>
<a name="l00222"></a>00222                 <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">float</span><span class="keyword">&gt;</span>(- p.<a class="code" href="structOgre_1_1RenderablePass.html#88788b24efb00ee4d9cf8c4b75cf06ee" title="Pointer to the Renderable details.">renderable</a>-&gt;<a class="code" href="classOgre_1_1Renderable.html#32353addc2f1d02512314b5d1a53c5c1" title="Returns the camera-relative squared depth of this renderable.">getSquaredViewDepth</a>(camera));
<a name="l00223"></a>00223             }
<a name="l00224"></a>00224         };
<a name="l00225"></a>00225 
<a name="l00227"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#c4c356244366d78dccbc80a3125c4d36">00227</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1RadixSort.html" title="Class for performing a radix sort (fast comparison-less sort based on byte value)...">RadixSort&lt;RenderablePassList, RenderablePass, float&gt;</a> msRadixSorter2;
<a name="l00228"></a>00228 
<a name="l00230"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#e9a31d2cd0e88ce11ba006d04cb7ac0d">00230</a>         <a class="code" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> mOrganisationMode;
<a name="l00231"></a>00231 
<a name="l00233"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#3b34af9f4be41db1386d479720ce602e">00233</a>         PassGroupRenderableMap mGrouped;
<a name="l00235"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#b800c1e93b112978e82e22f00046e3d1">00235</a>         RenderablePassList mSortedDescending;
<a name="l00236"></a>00236 
<a name="l00238"></a>00238         <span class="keywordtype">void</span> acceptVisitorGrouped(<a class="code" href="classOgre_1_1QueuedRenderableVisitor.html" title="Visitor interface for items in a QueuedRenderableCollection.">QueuedRenderableVisitor</a>* visitor) <span class="keyword">const</span>;
<a name="l00240"></a>00240         <span class="keywordtype">void</span> acceptVisitorDescending(<a class="code" href="classOgre_1_1QueuedRenderableVisitor.html" title="Visitor interface for items in a QueuedRenderableCollection.">QueuedRenderableVisitor</a>* visitor) <span class="keyword">const</span>;
<a name="l00242"></a>00242         <span class="keywordtype">void</span> acceptVisitorAscending(<a class="code" href="classOgre_1_1QueuedRenderableVisitor.html" title="Visitor interface for items in a QueuedRenderableCollection.">QueuedRenderableVisitor</a>* visitor) <span class="keyword">const</span>;
<a name="l00243"></a>00243 
<a name="l00244"></a>00244     <span class="keyword">public</span>:
<a name="l00245"></a>00245         <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a>();
<a name="l00246"></a>00246         ~<a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a>();
<a name="l00247"></a>00247 
<a name="l00249"></a>00249         <span class="keywordtype">void</span> clear(<span class="keywordtype">void</span>);
<a name="l00250"></a>00250 
<a name="l00256"></a>00256         <span class="keywordtype">void</span> removePassGroup(<a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>* p);
<a name="l00257"></a>00257         
<a name="l00263"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#fde7f8e139270c04158880ea90da71a0">00263</a>         <span class="keywordtype">void</span> resetOrganisationModes(<span class="keywordtype">void</span>) 
<a name="l00264"></a>00264         { 
<a name="l00265"></a>00265             mOrganisationMode = 0; 
<a name="l00266"></a>00266         }
<a name="l00267"></a>00267         
<a name="l00273"></a><a class="code" href="classOgre_1_1QueuedRenderableCollection.html#1f30f771db3b5dd9f520a3e17ff9e1bb">00273</a>         <span class="keywordtype">void</span> addOrganisationMode(<a class="code" href="classOgre_1_1QueuedRenderableCollection.html#b44ba16fe8e8c0247234d4e6edfae844" title="Organisation modes required for this collection.">OrganisationMode</a> om) 
<a name="l00274"></a>00274         { 
<a name="l00275"></a>00275             mOrganisationMode |= om; 
<a name="l00276"></a>00276         }
<a name="l00277"></a>00277 
<a name="l00279"></a>00279         <span class="keywordtype">void</span> addRenderable(<a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>* pass, <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* rend);
<a name="l00280"></a>00280         
<a name="l00284"></a>00284         <span class="keywordtype">void</span> sort(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam);
<a name="l00285"></a>00285 
<a name="l00292"></a>00292         <span class="keywordtype">void</span> acceptVisitor(<a class="code" href="classOgre_1_1QueuedRenderableVisitor.html" title="Visitor interface for items in a QueuedRenderableCollection.">QueuedRenderableVisitor</a>* visitor, OrganisationMode om) <span class="keyword">const</span>;
<a name="l00293"></a>00293         
<a name="l00294"></a>00294     };
<a name="l00295"></a>00295 
<a name="l00315"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html">00315</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RenderPriorityGroup.html" title="Collection of renderables by priority.">RenderPriorityGroup</a>
<a name="l00316"></a>00316     {
<a name="l00317"></a>00317     <span class="keyword">protected</span>:
<a name="l00318"></a>00318 
<a name="l00320"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#fa964877920d284c972b4684c54fe273">00320</a>         <a class="code" href="classOgre_1_1RenderQueueGroup.html" title="A grouping level underneath RenderQueue which groups renderables to be issued at...">RenderQueueGroup</a>* mParent;
<a name="l00321"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#f98ab3bc78759bb0f6fe921d95681c55">00321</a>         <span class="keywordtype">bool</span> mSplitPassesByLightingType;
<a name="l00322"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#6cb0571ecf3cb5199d95e4ff056499ff">00322</a>         <span class="keywordtype">bool</span> mSplitNoShadowPasses;
<a name="l00323"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#a978e09317bbe8cf1062b4157510ea65">00323</a>         <span class="keywordtype">bool</span> mShadowCastersNotReceivers;
<a name="l00325"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#b8560ed065a3001ee34d6fbc46de5527">00325</a>         <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a> mSolidsBasic;
<a name="l00327"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#56ebcce57f1603250d9b6018b06e98d3">00327</a>         <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a> mSolidsDiffuseSpecular;
<a name="l00329"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#ed4224f5234e3706795dfc4fa16159ed">00329</a>         <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a> mSolidsDecal;
<a name="l00331"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#dc851b6c07b963d53f2aedd53dda0b45">00331</a>         <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a> mSolidsNoShadowReceive;
<a name="l00333"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#cacd2f33af2aceae1bc5775c4457d7da">00333</a>         <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a> mTransparents;
<a name="l00334"></a>00334 
<a name="l00336"></a>00336         <span class="keywordtype">void</span> removePassEntry(<a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>* p);
<a name="l00337"></a>00337 
<a name="l00339"></a>00339         <span class="keywordtype">void</span> addSolidRenderable(<a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* pTech, <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* rend, <span class="keywordtype">bool</span> toNoShadowMap);
<a name="l00341"></a>00341         <span class="keywordtype">void</span> addSolidRenderableSplitByLightType(<a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* pTech, <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* rend);
<a name="l00343"></a>00343         <span class="keywordtype">void</span> addTransparentRenderable(<a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* pTech, <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* rend);
<a name="l00344"></a>00344 
<a name="l00345"></a>00345     <span class="keyword">public</span>:
<a name="l00346"></a>00346         <a class="code" href="classOgre_1_1RenderPriorityGroup.html" title="Collection of renderables by priority.">RenderPriorityGroup</a>(<a class="code" href="classOgre_1_1RenderQueueGroup.html" title="A grouping level underneath RenderQueue which groups renderables to be issued at...">RenderQueueGroup</a>* parent, 
<a name="l00347"></a>00347             <span class="keywordtype">bool</span> splitPassesByLightingType,
<a name="l00348"></a>00348             <span class="keywordtype">bool</span> splitNoShadowPasses, 
<a name="l00349"></a>00349             <span class="keywordtype">bool</span> shadowCastersNotReceivers); 
<a name="l00350"></a>00350            
<a name="l00351"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#0a18c4c1f2c29571f606cbac7861c3a9">00351</a>         ~<a class="code" href="classOgre_1_1RenderPriorityGroup.html" title="Collection of renderables by priority.">RenderPriorityGroup</a>() { }
<a name="l00352"></a>00352 
<a name="l00357"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#1d55ed0d465b381303fd4b0c2e7646a2">00357</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a>&amp; getSolidsBasic(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00358"></a>00358 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mSolidsBasic; }
<a name="l00361"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#327e07de0d0136a5e489a44e3982b8a4">00361</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a>&amp; getSolidsDiffuseSpecular(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00362"></a>00362 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mSolidsDiffuseSpecular; }
<a name="l00365"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#745936859235b031c2399a5b3c45df4e">00365</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a>&amp; getSolidsDecal(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00366"></a>00366 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mSolidsDecal; }
<a name="l00369"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#f5e28105a6ca20ed978cf206f9406e4d">00369</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a>&amp; getSolidsNoShadowReceive(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00370"></a>00370 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mSolidsNoShadowReceive; }
<a name="l00372"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#fd96c5fa208a0cabd16b8d6558425e62">00372</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html" title="Lowest level collection of renderables.">QueuedRenderableCollection</a>&amp; getTransparents(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00373"></a>00373 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mTransparents; }
<a name="l00374"></a>00374 
<a name="l00375"></a>00375 
<a name="l00382"></a>00382         <span class="keywordtype">void</span> resetOrganisationModes(<span class="keywordtype">void</span>);
<a name="l00383"></a>00383         
<a name="l00390"></a>00390         <span class="keywordtype">void</span> addOrganisationMode(<a class="code" href="classOgre_1_1QueuedRenderableCollection.html#b44ba16fe8e8c0247234d4e6edfae844" title="Organisation modes required for this collection.">QueuedRenderableCollection::OrganisationMode</a> om); 
<a name="l00391"></a>00391 
<a name="l00398"></a>00398         <span class="keywordtype">void</span> defaultOrganisationMode(<span class="keywordtype">void</span>); 
<a name="l00399"></a>00399 
<a name="l00401"></a>00401         <span class="keywordtype">void</span> addRenderable(<a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* pRend, <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* pTech);
<a name="l00402"></a>00402 
<a name="l00405"></a>00405         <span class="keywordtype">void</span> sort(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam);
<a name="l00406"></a>00406 
<a name="l00409"></a>00409         <span class="keywordtype">void</span> clear(<span class="keywordtype">void</span>);
<a name="l00410"></a>00410 
<a name="l00414"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#17541d778d6d971eb7ecc0141ca7bbce">00414</a>         <span class="keywordtype">void</span> setSplitPassesByLightingType(<span class="keywordtype">bool</span> split)
<a name="l00415"></a>00415         {
<a name="l00416"></a>00416             mSplitPassesByLightingType = split;
<a name="l00417"></a>00417         }
<a name="l00418"></a>00418 
<a name="l00422"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#82ce83d78ddac522340a9bb9dfd4aa76">00422</a>         <span class="keywordtype">void</span> setSplitNoShadowPasses(<span class="keywordtype">bool</span> split)
<a name="l00423"></a>00423         {
<a name="l00424"></a>00424             mSplitNoShadowPasses = split;
<a name="l00425"></a>00425         }
<a name="l00426"></a>00426 
<a name="l00430"></a><a class="code" href="classOgre_1_1RenderPriorityGroup.html#d00485a29818222dffa8b4b42748c57f">00430</a>         <span class="keywordtype">void</span> setShadowCastersCannotBeReceivers(<span class="keywordtype">bool</span> ind)
<a name="l00431"></a>00431         {
<a name="l00432"></a>00432             mShadowCastersNotReceivers = ind;
<a name="l00433"></a>00433         }
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 
<a name="l00436"></a>00436 
<a name="l00437"></a>00437     };
<a name="l00438"></a>00438 
<a name="l00439"></a>00439 
<a name="l00447"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html">00447</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RenderQueueGroup.html" title="A grouping level underneath RenderQueue which groups renderables to be issued at...">RenderQueueGroup</a>
<a name="l00448"></a>00448     {
<a name="l00449"></a>00449     <span class="keyword">public</span>:
<a name="l00450"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#33650a9641d40269f18d44be60006d31">00450</a>         <span class="keyword">typedef</span> std::map&lt;ushort, RenderPriorityGroup*, std::less&lt;ushort&gt; &gt; PriorityMap;
<a name="l00451"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#38216d5a4828871b53e5fbecdc8d4984">00451</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">MapIterator&lt;PriorityMap&gt;</a> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">PriorityMapIterator</a>;
<a name="l00452"></a>00452     <span class="keyword">protected</span>:
<a name="l00453"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#f9f686713ffc4826d877050b9eeb7269">00453</a>         <a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* mParent;
<a name="l00454"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#6ea0e9f15de8415698537ebab761b941">00454</a>         <span class="keywordtype">bool</span> mSplitPassesByLightingType;
<a name="l00455"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#512ffe61ae9cf4871096a547d500a3c9">00455</a>         <span class="keywordtype">bool</span> mSplitNoShadowPasses;
<a name="l00456"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#cb8f17ce35fe836bbcc33e4549d501e0">00456</a>         <span class="keywordtype">bool</span> mShadowCastersNotReceivers;
<a name="l00458"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#89c61e07d1956e97cf067aaf9657bc31">00458</a>         PriorityMap mPriorityGroups;
<a name="l00460"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#5c4eaacfc8c686034b7795580f748f89">00460</a>         <span class="keywordtype">bool</span> mShadowsEnabled;
<a name="l00461"></a>00461 
<a name="l00462"></a>00462 
<a name="l00463"></a>00463     <span class="keyword">public</span>:
<a name="l00464"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#a8f83bb601e8344a255fc2aafbc958ee">00464</a>         <a class="code" href="classOgre_1_1RenderQueueGroup.html" title="A grouping level underneath RenderQueue which groups renderables to be issued at...">RenderQueueGroup</a>(<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* parent,
<a name="l00465"></a>00465             <span class="keywordtype">bool</span> splitPassesByLightingType,
<a name="l00466"></a>00466             <span class="keywordtype">bool</span> splitNoShadowPasses,
<a name="l00467"></a>00467             <span class="keywordtype">bool</span> shadowCastersNotReceivers) 
<a name="l00468"></a>00468             : mParent(parent)
<a name="l00469"></a>00469             , mSplitPassesByLightingType(splitPassesByLightingType)
<a name="l00470"></a>00470             , mSplitNoShadowPasses(splitNoShadowPasses)
<a name="l00471"></a>00471             , mShadowCastersNotReceivers(shadowCastersNotReceivers)
<a name="l00472"></a>00472             , mShadowsEnabled(true)
<a name="l00473"></a>00473         {
<a name="l00474"></a>00474         }
<a name="l00475"></a>00475 
<a name="l00476"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#c12bd8451907d485889812b0a6b6ceca">00476</a>         ~<a class="code" href="classOgre_1_1RenderQueueGroup.html" title="A grouping level underneath RenderQueue which groups renderables to be issued at...">RenderQueueGroup</a>() {
<a name="l00477"></a>00477             <span class="comment">// destroy contents now</span>
<a name="l00478"></a>00478             PriorityMap::iterator i;
<a name="l00479"></a>00479             <span class="keywordflow">for</span> (i = mPriorityGroups.begin(); i != mPriorityGroups.end(); ++i)
<a name="l00480"></a>00480             {
<a name="l00481"></a>00481                 <span class="keyword">delete</span> i-&gt;second;
<a name="l00482"></a>00482             }
<a name="l00483"></a>00483         }
<a name="l00484"></a>00484 
<a name="l00486"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#9225e3493596e1701e583721d1846f24">00486</a>         <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">PriorityMapIterator</a> getIterator(<span class="keywordtype">void</span>)
<a name="l00487"></a>00487         {
<a name="l00488"></a>00488             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">PriorityMapIterator</a>(mPriorityGroups.begin(), mPriorityGroups.end());
<a name="l00489"></a>00489         }
<a name="l00490"></a>00490 
<a name="l00492"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#0bd953e5e30d631542ef7d85158b017e">00492</a>         <span class="keywordtype">void</span> addRenderable(<a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* pRend, <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* pTech, <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> priority)
<a name="l00493"></a>00493         {
<a name="l00494"></a>00494             <span class="comment">// Check if priority group is there</span>
<a name="l00495"></a>00495             PriorityMap::iterator i = mPriorityGroups.find(priority);
<a name="l00496"></a>00496             <a class="code" href="classOgre_1_1RenderPriorityGroup.html" title="Collection of renderables by priority.">RenderPriorityGroup</a>* pPriorityGrp;
<a name="l00497"></a>00497             <span class="keywordflow">if</span> (i == mPriorityGroups.end())
<a name="l00498"></a>00498             {
<a name="l00499"></a>00499                 <span class="comment">// Missing, create</span>
<a name="l00500"></a>00500                 pPriorityGrp = <span class="keyword">new</span> <a class="code" href="classOgre_1_1RenderPriorityGroup.html" title="Collection of renderables by priority.">RenderPriorityGroup</a>(<span class="keyword">this</span>, 
<a name="l00501"></a>00501                     mSplitPassesByLightingType,
<a name="l00502"></a>00502                     mSplitNoShadowPasses, 
<a name="l00503"></a>00503                     mShadowCastersNotReceivers);
<a name="l00504"></a>00504                 mPriorityGroups.insert(PriorityMap::value_type(priority, pPriorityGrp));
<a name="l00505"></a>00505             }
<a name="l00506"></a>00506             <span class="keywordflow">else</span>
<a name="l00507"></a>00507             {
<a name="l00508"></a>00508                 pPriorityGrp = i-&gt;second;
<a name="l00509"></a>00509             }
<a name="l00510"></a>00510 
<a name="l00511"></a>00511             <span class="comment">// Add</span>
<a name="l00512"></a>00512             pPriorityGrp-&gt;<a class="code" href="classOgre_1_1RenderPriorityGroup.html#b09fd661aa02509a1e4f83b18f5da74f" title="Add a renderable to this group.">addRenderable</a>(pRend, pTech);
<a name="l00513"></a>00513 
<a name="l00514"></a>00514         }
<a name="l00515"></a>00515 
<a name="l00523"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#eeaaf69657b5425e8f294466f0061a41">00523</a>         <span class="keywordtype">void</span> clear(<span class="keywordtype">bool</span> destroy = <span class="keyword">false</span>)
<a name="l00524"></a>00524         {
<a name="l00525"></a>00525             PriorityMap::iterator i, iend;
<a name="l00526"></a>00526             iend = mPriorityGroups.end();
<a name="l00527"></a>00527             <span class="keywordflow">for</span> (i = mPriorityGroups.begin(); i != iend; ++i)
<a name="l00528"></a>00528             {
<a name="l00529"></a>00529                 <span class="keywordflow">if</span> (destroy)
<a name="l00530"></a>00530                     <span class="keyword">delete</span> i-&gt;second;
<a name="l00531"></a>00531                 <span class="keywordflow">else</span>
<a name="l00532"></a>00532                     i-&gt;second-&gt;clear();
<a name="l00533"></a>00533             }
<a name="l00534"></a>00534 
<a name="l00535"></a>00535             <span class="keywordflow">if</span> (destroy)
<a name="l00536"></a>00536                 mPriorityGroups.clear();
<a name="l00537"></a>00537 
<a name="l00538"></a>00538         }
<a name="l00539"></a>00539 
<a name="l00552"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#180a462bafa9b9d472a59d044657e6ef">00552</a>         <span class="keywordtype">void</span> setShadowsEnabled(<span class="keywordtype">bool</span> enabled) { mShadowsEnabled = enabled; }
<a name="l00553"></a>00553 
<a name="l00555"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#1494737d903b3e54f3b1694874c2c034">00555</a>         <span class="keywordtype">bool</span> getShadowsEnabled(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mShadowsEnabled; }
<a name="l00556"></a>00556 
<a name="l00560"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#a9136681bf8704ada4af84f2c30be7b3">00560</a>         <span class="keywordtype">void</span> setSplitPassesByLightingType(<span class="keywordtype">bool</span> split)
<a name="l00561"></a>00561         {
<a name="l00562"></a>00562             mSplitPassesByLightingType = split;
<a name="l00563"></a>00563             PriorityMap::iterator i, iend;
<a name="l00564"></a>00564             iend = mPriorityGroups.end();
<a name="l00565"></a>00565             <span class="keywordflow">for</span> (i = mPriorityGroups.begin(); i != iend; ++i)
<a name="l00566"></a>00566             {
<a name="l00567"></a>00567                 i-&gt;second-&gt;setSplitPassesByLightingType(split);
<a name="l00568"></a>00568             }
<a name="l00569"></a>00569         }
<a name="l00574"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#9d53fac5486bb4379965858840900263">00574</a>         <span class="keywordtype">void</span> setSplitNoShadowPasses(<span class="keywordtype">bool</span> split)
<a name="l00575"></a>00575         {
<a name="l00576"></a>00576             mSplitNoShadowPasses = split;
<a name="l00577"></a>00577             PriorityMap::iterator i, iend;
<a name="l00578"></a>00578             iend = mPriorityGroups.end();
<a name="l00579"></a>00579             <span class="keywordflow">for</span> (i = mPriorityGroups.begin(); i != iend; ++i)
<a name="l00580"></a>00580             {
<a name="l00581"></a>00581                 i-&gt;second-&gt;setSplitNoShadowPasses(split);
<a name="l00582"></a>00582             }
<a name="l00583"></a>00583         }
<a name="l00587"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#5c2e2f614fe51fb1e6954b28f4c3a366">00587</a>         <span class="keywordtype">void</span> setShadowCastersCannotBeReceivers(<span class="keywordtype">bool</span> ind)
<a name="l00588"></a>00588         {
<a name="l00589"></a>00589             mShadowCastersNotReceivers = ind;
<a name="l00590"></a>00590             PriorityMap::iterator i, iend;
<a name="l00591"></a>00591             iend = mPriorityGroups.end();
<a name="l00592"></a>00592             <span class="keywordflow">for</span> (i = mPriorityGroups.begin(); i != iend; ++i)
<a name="l00593"></a>00593             {
<a name="l00594"></a>00594                 i-&gt;second-&gt;setShadowCastersCannotBeReceivers(ind);
<a name="l00595"></a>00595             }
<a name="l00596"></a>00596         }
<a name="l00603"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#4fcd2c524232e0708786959bf74fe153">00603</a>         <span class="keywordtype">void</span> resetOrganisationModes(<span class="keywordtype">void</span>)
<a name="l00604"></a>00604         {
<a name="l00605"></a>00605             PriorityMap::iterator i, iend;
<a name="l00606"></a>00606             iend = mPriorityGroups.end();
<a name="l00607"></a>00607             <span class="keywordflow">for</span> (i = mPriorityGroups.begin(); i != iend; ++i)
<a name="l00608"></a>00608             {
<a name="l00609"></a>00609                 i-&gt;second-&gt;resetOrganisationModes();
<a name="l00610"></a>00610             }
<a name="l00611"></a>00611         }
<a name="l00612"></a>00612         
<a name="l00619"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#195e1d749ca78952f9e4c222d6a536c3">00619</a>         <span class="keywordtype">void</span> addOrganisationMode(<a class="code" href="classOgre_1_1QueuedRenderableCollection.html#b44ba16fe8e8c0247234d4e6edfae844" title="Organisation modes required for this collection.">QueuedRenderableCollection::OrganisationMode</a> om)
<a name="l00620"></a>00620         {
<a name="l00621"></a>00621             PriorityMap::iterator i, iend;
<a name="l00622"></a>00622             iend = mPriorityGroups.end();
<a name="l00623"></a>00623             <span class="keywordflow">for</span> (i = mPriorityGroups.begin(); i != iend; ++i)
<a name="l00624"></a>00624             {
<a name="l00625"></a>00625                 i-&gt;second-&gt;addOrganisationMode(om);
<a name="l00626"></a>00626             }
<a name="l00627"></a>00627         }
<a name="l00628"></a>00628 
<a name="l00635"></a><a class="code" href="classOgre_1_1RenderQueueGroup.html#0cf70d2d850ef3746957b337b1bba4d0">00635</a>         <span class="keywordtype">void</span> defaultOrganisationMode(<span class="keywordtype">void</span>)
<a name="l00636"></a>00636         {
<a name="l00637"></a>00637             PriorityMap::iterator i, iend;
<a name="l00638"></a>00638             iend = mPriorityGroups.end();
<a name="l00639"></a>00639             <span class="keywordflow">for</span> (i = mPriorityGroups.begin(); i != iend; ++i)
<a name="l00640"></a>00640             {
<a name="l00641"></a>00641                 i-&gt;second-&gt;defaultOrganisationMode();
<a name="l00642"></a>00642             }
<a name="l00643"></a>00643         }
<a name="l00644"></a>00644 
<a name="l00645"></a>00645     };
<a name="l00646"></a>00646 
<a name="l00647"></a>00647 
<a name="l00648"></a>00648 
<a name="l00649"></a>00649 }
<a name="l00650"></a>00650 
<a name="l00651"></a>00651 <span class="preprocessor">#endif</span>
<a name="l00652"></a>00652 <span class="preprocessor"></span>
<a name="l00653"></a>00653 
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:54 2008
</p>
</body>
</html>
